' Rennautospiel

TYPE Teilb
	attr AS INTEGER
	slo AS INTEGER
	sro AS INTEGER
	slu AS INTEGER
	sru AS INTEGER
END TYPE

TYPE AutoB
	ptr AS INTEGER
	xOffs AS INTEGER
	yOffs AS INTEGER
	xGr AS INTEGER
	yGr AS INTEGER
END TYPE

TYPE lim
	xi AS INTEGER
	xa AS INTEGER
	yi AS INTEGER
	ya AS INTEGER
END TYPE

TYPE Spieler
	x AS SINGLE
	y AS SINGLE
	vx AS SINGLE
	vy AS SINGLE
	l AS lim
	v AS lim
	f AS INTEGER
	r AS INTEGER   ' Richtung, wo man herkommt
	typ AS INTEGER  ' Spielertyp (Tastatur/Joystick/Computer/Netzwerk usw.)
	na AS STRING * 12
END TYPE

DECLARE SUB ZeichneBahneditorCursor (t%, f%)
DECLARE SUB GibErklaerungAus (t$)
DECLARE SUB ErzeugeBieps ()
DECLARE SUB EditiereZeile (e$, e%)
DECLARE SUB GibSpielerDetailsAus (s%, m%)
DECLARE SUB FarbPrint (fg%, hg%, t$)
DECLARE FUNCTION LSetF$ (t$, l%)
DECLARE SUB ZeichneRennbahn ()
DECLARE FUNCTION Polarwinkel! (dx!, dy!)
DECLARE SUB ZeichneAuto (a AS Spieler, n%)
DECLARE SUB ZeichneTeil (x%, y%)
DECLARE FUNCTION Rennauto% (u!, v!)
DECLARE FUNCTION BestimmeFarbe% (p!)
DECLARE FUNCTION BestimmeLinearFarbe% (u!, v!)
DECLARE FUNCTION Bruecke% (u!, v!, f1%, f2%)
DECLARE FUNCTION Start% (u!, v!, f%)
DECLARE SUB InitialisiereRennbahn ()
DECLARE SUB ZeigeCursor (x%, y%, el%, t$)
DECLARE SUB ZeichneRahmen (x1%, y1%, x2%, y2%, f%)
DECLARE SUB SpeichereRennbahn ()
DECLARE SUB LadeRennbahn ()
DECLARE FUNCTION FuehrNull$ (w%, a%)

DIM SHARED Pi!, aDet(24) AS AutoB, AndM%(5193), aut%(5193, 2)
DIM SHARED teil%(421, 30), tbesch(29) AS Teilb, bahn%(-1 TO 6, -1 TO 5)
DIM SHARED clr%(291, 6), sp(6) AS Spieler, rennb$, aSpie%, aRund%
DIM SHARED tasten%(27), Ins%

DIM ma%(351), mb%(37), trans%(900), tRoh!(15), mp$(6), mmod%(3, 3)

Pi! = 4! * ATN(1!)

FOR i% = 0 TO 29
	READ tbesch(i%).attr, tbesch(i%).slo, tbesch(i%).sro, tbesch(i%).slu, tbesch(i%).sru
NEXT i%

DATA 0, 30, 30, 30, 30, 1, 14, 15, 14, 15, 2, 20, 21, 20, 21
DATA 4, 4, 5, 10, 11, 8, 0, 1, 6, 7, 16, 6, 7, 0, 1
DATA 32, 10, 11, 4, 5, 3, 26, 27, 26, 27, 3, 18, 23, 18, 23
DATA 3, 19, 22, 19, 22, 1, 14, 29, 14, 29, 2, 25, 28, 20, 21
DATA 1, 24, 15, 24, 15, 2, 20, 21, 25, 28, 5, 16, 17, 14, 15
DATA 6, 20, 3, 20, 9, 10, 2, 21, 8, 21, 9, 12, 13, 14, 15
DATA 17, 14, 15, 12, 13, 18, 8, 21, 2, 21, 34, 20, 9, 20, 3
DATA 33, 14, 15, 16, 17, 37, 16, 17, 16, 17, 14, 2, 3, 8, 9
DATA 25, 12, 13, 12, 13, 50, 8, 9, 2, 3, 36, 4, 5, 4, 5
DATA 12, 0, 5, 6, 11, 24, 0, 1, 0, 1, 48, 6, 11, 0, 5

FOR i% = 0 TO 27
	READ tasten%(i%)
NEXT i%

DATA 331, 333, 328, 336, 97, 115, 100, 120, 106, 107, 108, 44, 52, 54, 56, 50
DATA 102, 103, 104, 98, 148, 132, 13, 36, 49, 50, 51, 119

FOR i% = 0 TO 6
	READ mp$(i%)
NEXT i%

DATA "Spiel starten", "Anleitung", "Rennbahneditor", "Programm beenden"
DATA "Aktuelle Rennbahn:", "Anzahl Spieler:", "Anzahl Runden:"

FOR i% = 0 TO 3
	FOR j% = 0 TO 3
		READ mmod%(j%, i%)
	NEXT j%
NEXT i%
DATA 1, 8, 0, 16, 32, 2, 16, 0, 0, 4, 1, 32, 4, 0, 8, 2

SCREEN 9
LOCATE 22, 1
PRINT "Grafiken werden initialisiert - bitte Geduld!"

' Auto in allen Positionen
h% = 0
FOR i% = 0 TO 12
	w! = CSNG(i%) * Pi! / 24!
	vx! = COS(w!)
	vy! = SIN(w!)
	xa% = -10
	xi% = 50
	ya% = -10
	yi% = 50
	' Ausputzen
	LINE (0, 0)-(143, 35), 0, BF
	LINE (144, 0)-(191, 35), 15, BF
	FOR k% = 0 TO 35
		y! = 17.5 - CSNG(k%)
		FOR l% = 0 TO 47
			x! = (CSNG(l%) - 23.5) * 35! / 48!
			q% = Rennauto(x! * vx! + y! * vy!, x! * vy! - y! * vx!)
			IF q% <> 7 THEN
				IF l% < xi% THEN xi% = l%
				IF l% > xa% THEN xa% = l%
				IF k% < yi% THEN yi% = k%
				IF k% > ya% THEN ya% = k%
				PSET (l%, k%), q%
				IF (q% AND 7) = 1 THEN
					PSET (48 + l%, k%), q% + 1
					PSET (96 + l%, k%), q% + 3
				ELSE
					PSET (48 + l%, k%), q%
					PSET (96 + l%, k%), q%
				END IF
				PSET (144 + l%, k%), 0
			END IF
		NEXT l%
	NEXT k%
	aDet(i%).ptr = h%
	aDet(i%).xOffs = 24 - xi%
	aDet(i%).yOffs = 18 - yi%
	aDet(i%).xGr = xa% - xi%
	aDet(i%).yGr = ya% - yi%
	FOR k% = 0 TO 2
		GET (xi% + 48 * k%, yi%)-STEP(aDet(i%).xGr, aDet(i%).yGr), aut%(h%, k%)
	NEXT k%
	GET (xi% + 144, yi%)-STEP(aDet(i%).xGr, aDet(i%).yGr), AndM%(h%)
	h% = h% + (aDet(i%).xGr \ 8 + 1) * (aDet(i%).yGr + 1) * 2 + 2
NEXT i%

' brige Fahrzeuge mittels Spiegelung
FOR i% = 13 TO 24
	aDet(i%) = aDet(24 - i%)
	aDet(i%).xOffs = aDet(i%).xGr + 1 - aDet(i%).xOffs
	FOR j% = 0 TO 2
		PUT (0, 0), aut%(aDet(i%).ptr, j%), PSET
		FOR k% = 0 TO aDet(i%).xGr
			GET (k%, 0)-STEP(0, aDet(i%).yGr), ma%
			PUT (95 - k%, 0), ma%, PSET
		NEXT k%
		GET (95 - aDet(i%).xGr, 0)-(95, aDet(i%).yGr), aut%(h%, j%)
	NEXT j%
	PUT (0, 0), AndM%(aDet(i%).ptr), PSET
	FOR k% = 0 TO aDet(i%).xGr
		GET (k%, 0)-STEP(0, aDet(i%).yGr), ma%
		PUT (95 - k%, 0), ma%, PSET
	NEXT k%
	GET (95 - aDet(i%).xGr, 0)-(95, aDet(i%).yGr), AndM%(h%)
	aDet(i%).ptr = h%
	h% = h% + aDet(25 - i%).ptr - aDet(24 - i%).ptr
NEXT i%

' Teile erzeugen
' Kurve
FOR i% = 0 TO 69
	y! = CSNG(i%) + .5
	y2! = y! * y!
	FOR j% = 0 TO 95
		x! = (CSNG(j%) + .5) * 35! / 48!
		z% = BestimmeFarbe(SQR(x! * x! + y2!))
		IF z% < 0 THEN
			w! = ATN(y! / x!) / Pi!
			SELECT CASE z%
			CASE -1
				w! = 8! * w!
			CASE -2
				w! = 12! * w!
			CASE -3
				w! = 4! * w!
			CASE -4
				w! = 28! * w!
			CASE -5
				w! = 4! * w!
			CASE ELSE
				STOP ' Sollte nicht vorkommen
			END SELECT
			t! = ABS(w! - INT(w!) - .5)
			SELECT CASE z%
			CASE IS <= -4
				IF t! < 5! / 14! THEN
					f% = 2
				ELSE
					f% = 8
				END IF
			CASE IS <= -2
				IF t! < 3! / 14! THEN
					f% = 15
				ELSE
					f% = 4
				END IF
			CASE ELSE
				IF t! < 2! / 7! THEN
					f% = 7
				ELSE
					f% = 15
				END IF
			END SELECT
			PSET (j%, i%), f%
		ELSE
			PSET (j%, i%), z%
		END IF
	NEXT j%
NEXT i%

FOR i% = 0 TO 34
	y! = CSNG(i%) + .5
	FOR j% = 0 TO 95
		x! = (CSNG(j%) + .5) * 35! / 48!
		' Gerade horizontal
		PSET (96 + j%, 70 + i%), BestimmeLinearFarbe(y!, x!)
		' Weiche horizontal
		IF x! * x! < (35! - y!) * 140! THEN
			PSET (j%, 70 + i%), POINT(j%, i%)
		ELSE
			PSET (j%, 70 + i%), POINT(96 + j%, 70 + i%)
		END IF
	NEXT j%
NEXT i%

FOR i% = 0 TO 69
	y! = CSNG(i%) + .5
	FOR j% = 0 TO 47
		x! = (CSNG(j%) + .5) * 35! / 48!
		' Geraden
		PSET (96 + j%, 105 + i%), BestimmeLinearFarbe(x!, y!)
		' Weiche vertikal
		IF y! * y! < (35! - x!) * 140! THEN
			PSET (96 + j%, i%), POINT(j%, i%)
		ELSE
			PSET (96 + j%, i%), POINT(96 + j%, 105 + i%)
		END IF
	NEXT j%
NEXT i%

' Einzelne Teile
FOR i% = 0 TO 34
	y! = CSNG(i%) + .5
	FOR j% = 0 TO 47
		x! = (CSNG(j%) + .5) * 35! / 48!
		' Kreuzung
		IF x! > y! THEN
			PSET (96 + j%, 140 + i%), POINT(96 + j%, 105 + i%)
		ELSE
			PSET (96 + j%, 140 + i%), POINT(96 + j%, 70 + i%)
		END IF
		' Brcke horizontal
		PSET (j%, 105 + i%), Bruecke(x!, y!, POINT(96 + j%, 70 + i%), POINT(96 + j%, 105 + i%))
		' Brcke vertikal
		PSET (48 + j%, 105 + i%), Bruecke(y!, x!, POINT(96 + j%, 105 + i%), POINT(96 + j%, 70 + i%))
		' Start horizontal
		PSET (j%, 140 + i%), Start(x!, y!, POINT(96 + j%, 70 + i%))
		' Start vertikal
		PSET (48 + j%, 140 + i%), Start(y!, x!, POINT(96 + j%, 105 + i%))
	NEXT j%
NEXT i%

' Spiegeln
FOR i% = 1 TO 17
	GET (0, 52 - i%)-STEP(143, 0), ma%
	GET (0, 52 + i%)-STEP(143, 0), mb%
	PUT (0, 52 + i%), ma%, PSET
	PUT (0, 52 - i%), mb%, PSET
NEXT i%
FOR i% = 0 TO 143
	GET (i%, 0)-STEP(0, 174), ma%
	PUT (287 - i%, 0), ma%, PSET
NEXT i%

' Wiese
LINE (0, 175)-STEP(47, 34), 2, BF

' Ausschneiden
FOR i% = 0 TO 30
	GET (48 * (i% MOD 6), 35 * (i% \ 6))-STEP(47, 34), teil%(0, i%)
NEXT i%

rennb$ = LSetF$("demo", 8)
InitialisiereRennbahn
LadeRennbahn
aSpie% = 7
aRund% = 3
mp1% = 0
mp2% = 0
Ins% = -1
FOR i% = 0 TO 6
	sp(i%).typ = i%
	sp(i%).na = LSetF$("Spieler" + STR$(i% + 1), 12)
	READ sp(i%).f
NEXT i%
DATA 1, 5, 3, 4, 2, 6, 7

' Hauptschleife/Spiel
DO
	COLOR 7
	CLS
	LOCATE 1, 23
	COLOR 13
	PRINT "Autorennen (c) 2001 by Andreas Meile"
	LOCATE 2, 11
	COLOR 4
	PRINT "e-Mail: ";
	COLOR 11
	PRINT "andreas@hofen.ch ";
	COLOR 4
	PRINT "WWW: ";
	COLOR 11
	PRINT "http://www.hofen.ch/~andreas/"
	LOCATE 4, 36
	COLOR 14
	PRINT "Hauptmen"
	COLOR 5
	FOR i% = 0 TO 6
		LOCATE 6 + i%, 20
		PRINT mp$(i%);
	NEXT i%
	COLOR 6
	LOCATE 10, 39
	PRINT rennb$;
	LOCATE 11, 36
	PRINT FuehrNull$(aSpie%, 1);
	LOCATE 12, 35
	PRINT FuehrNull$(aRund%, 2);

	COLOR 7
	LOCATE 14, 10
	PRINT "Spielername  Typ         Farbe  Detaileinstellungen"
	LOCATE 15, 10
	PRINT ""
	FOR i% = 0 TO aSpie% - 1
		GibSpielerDetailsAus i%, 0
	NEXT i%

	Drinbleib% = -1
	WHILE Drinbleib%
		GibErklaerungAus "Auswahl mit Pfeiltasten und Eingabetaste"
		IF mp1% < 7 THEN
			LOCATE 6 + mp1%, 20
			FarbPrint 5, 7, mp$(mp1%)
		ELSE
			GibSpielerDetailsAus mp1% - 7, mp2% + 1
		END IF
		DO
			tt$ = INKEY$
		LOOP WHILE tt$ = ""
		IF mp1% < 7 THEN
			LOCATE 6 + mp1%, 20
			FarbPrint 5, 0, mp$(mp1%)
		ELSE
			GibSpielerDetailsAus mp1% - 7, 0
		END IF
		SELECT CASE tt$
		CASE CHR$(0) + "H"
			mp1% = (mp1% + 6 + aSpie%) MOD (7 + aSpie%)
		CASE CHR$(0) + "P"
			mp1% = (mp1% + 1) MOD (7 + aSpie%)
		CASE CHR$(0) + "K"
			mp2% = (mp2% + 6) MOD 7
		CASE CHR$(0) + "M"
			mp2% = (mp2% + 1) MOD 7
		CASE CHR$(13)
			SELECT CASE mp1%
			CASE 4
				GibErklaerungAus "Name der Rennbahndatei eingeben"
				LOCATE 10, 39
				EditiereZeile rennb$, e%
			CASE 5
				GibErklaerungAus "Anzahl Spieler mit Pfeiltasten erhhen/reduzieren"
				alt% = aSpie%
				drinb2% = -1
				WHILE drinb2%
					LOCATE 11, 36
					FarbPrint 1, 15, FuehrNull$(aSpie%, 1)
					DO
						t$ = INKEY$
					LOOP WHILE t$ = ""
					a% = aSpie%
					SELECT CASE t$
					CASE "1" TO "7"
						aSpie% = ASC(t$) - 48
					CASE CHR$(0) + "H", CHR$(0) + "K"
						aSpie% = (aSpie% + 5) MOD 7 + 1
					CASE CHR$(0) + "M", CHR$(0) + "P"
						aSpie% = aSpie% MOD 7 + 1
					CASE CHR$(13)
						drinb2% = 0
					CASE CHR$(27)
						drinb2% = 0
						aSpie% = alt%
					CASE ELSE
						ErzeugeBieps
					END SELECT
					IF aSpie% > a% THEN
						FOR i% = a% TO aSpie% - 1
							GibSpielerDetailsAus i%, 0
						NEXT i%
					ELSEIF aSpie% < a% THEN
						FOR i% = aSpie% TO a% - 1
							LOCATE 16 + i%, 10
							PRINT SPACE$(55);
						NEXT i%
					END IF
				WEND
				COLOR 6
				LOCATE 11, 36
				PRINT FuehrNull$(aSpie%, 1);
			CASE 6
				GibErklaerungAus "Anzahl Runden mit Pfeiltasten erhhen/reduzieren"
				alt% = aRund%
				drinb2% = -1
				WHILE drinb2%
					LOCATE 12, 35
					FarbPrint 1, 15, FuehrNull$(aRund%, 2)
					DO
						t$ = INKEY$
					LOOP WHILE t$ = ""
					SELECT CASE t$
					CASE CHR$(0) + "H", CHR$(0) + "K"
						aRund% = (aRund% + 48) MOD 50 + 1
					CASE CHR$(0) + "M", CHR$(0) + "P"
						aRund% = aRund% MOD 50 + 1
					CASE CHR$(13)
						drinb2% = 0
					CASE CHR$(27)
						drinb2% = 0
						aRund% = alt%
					CASE ELSE
						ErzeugeBieps
					END SELECT
				WEND
				COLOR 6
				LOCATE 12, 35
				PRINT FuehrNull$(aRund%, 2);
			CASE IS >= 7
				SELECT CASE mp2%
				CASE 0
					GibErklaerungAus "Spielername eingeben"
					LOCATE 9 + mp1%, 10
					EditiereZeile sp(mp1% - 7).na, e%
				CASE 1
					GibErklaerungAus "Spielertyp mit Pfeiltasten auswhlen, Abschluss mit " + CHR$(17) + ""
					alt% = sp(mp1% - 7).typ
					drinb2% = -1
					WHILE drinb2%
						GibSpielerDetailsAus mp1% - 7, -2
						DO
							t$ = INKEY$
						LOOP WHILE t$ = ""
						SELECT CASE t$
						CASE CHR$(0) + "H", CHR$(0) + "K"
							sp(mp1% - 7).typ = (sp(mp1% - 7).typ + 11) MOD 12
						CASE CHR$(0) + "M", CHR$(0) + "P"
							sp(mp1% - 7).typ = (sp(mp1% - 7).typ + 1) MOD 12
						CASE CHR$(13)
							drinb2% = 0
						CASE CHR$(27)
							drinb2% = 0
							sp(mp1% - 7).typ = alt%
						CASE ELSE
							ErzeugeBieps
						END SELECT
					WEND
					IF sp(mp1% - 7).typ < 9 THEN
						' Gewisse Typen knnen nur von einem Spieler verwendet werden
						FOR i% = 0 TO 6
							IF sp(i%).typ = sp(mp1% - 7).typ AND i% <> mp1% - 7 THEN
								sp(i%).typ = alt%
								IF i% < aSpie% THEN
									GibSpielerDetailsAus i%, 0
								END IF
							END IF
						NEXT i%
					END IF
				CASE 2
					GibErklaerungAus "Autofarbe mit Pfeiltasten auswhlen, Abschluss mit " + CHR$(17) + ""
					alt% = sp(mp1% - 7).f
					drinb2% = -1
					WHILE drinb2%
						GibSpielerDetailsAus mp1% - 7, -3
						DO
							t$ = INKEY$
						LOOP WHILE t$ = ""
						SELECT CASE t$
						CASE CHR$(0) + "H", CHR$(0) + "K"
							sp(mp1% - 7).f = (sp(mp1% - 7).f + 5) MOD 7 + 1
						CASE CHR$(0) + "M", CHR$(0) + "P"
							sp(mp1% - 7).f = sp(mp1% - 7).f MOD 7 + 1
						CASE CHR$(13)
							drinb2% = 0
						CASE CHR$(27)
							drinb2% = 0
							sp(mp1% - 7).f = alt%
						CASE ELSE
							ErzeugeBieps
						END SELECT
					WEND
				CASE IS >= 3
					SELECT CASE sp(mp1% - 7).typ
					CASE 0 TO 6
						SELECT CASE mp2%
						CASE 3
							GibErklaerungAus "Bitte gewnschte Taste fr nach links lenken drcken"
						CASE 4
							GibErklaerungAus "Bitte gewnschte Taste fr nach rechts lenken drcken"
						CASE 5
							GibErklaerungAus "Bitte gewnschte Taste fr Gas geben drcken"
						CASE 6
							GibErklaerungAus "Bitte gewnschte Taste fr Bremsen drcken"
						END SELECT
						GibSpielerDetailsAus mp1% - 7, -1 - mp2%
						DO
							t$ = INKEY$
						LOOP WHILE t$ = ""
						IF UCASE$(t$) = "P" THEN
							ErzeugeBieps  ' Pause-Taste ist ungltig
						ELSEIF t$ <> CHR$(27) THEN
							h% = 4 * sp(mp1% - 7).typ + mp2% - 3
							alt% = tasten%(h%)
							t% = (LEN(t$) - 1) * 256 + ASC(RIGHT$(t$, 1))
							tasten%(h%) = t%
							' Auch Tasten knnen sinnvollerweise nur 1x verwendet werden
							FOR i% = 0 TO 27
								IF i% <> h% AND tasten%(i%) = t% THEN
									tasten%(i%) = alt%
									FOR j% = 0 TO 6
										IF sp(j%).typ = i% \ 4 THEN
											GibSpielerDetailsAus j%, 0
										END IF
									NEXT j%
								END IF
							NEXT i%
						END IF
					CASE 7 TO 8
						GibErklaerungAus "Joystick kalibrieren (nicht implementiert)"
					CASE IS >= 9
						GibErklaerungAus "Strategieparameter angeben (nicht impl.)"
					END SELECT
				END SELECT
				' Farbe kann nur von einem Spieler verwendet werden
				FOR i% = 0 TO 6
					IF sp(i%).f = sp(mp1% - 7).f AND i% <> mp1% - 7 THEN
						sp(i%).f = alt%
						IF i% < aSpie% THEN
							GibSpielerDetailsAus i%, 0
						END IF
					END IF
				NEXT i%
				GibSpielerDetailsAus mp1% - 7, 3
			CASE ELSE
				Drinbleib% = 0
			END SELECT
		END SELECT
	WEND
	SELECT CASE mp1%
	CASE 0
		GOSUB Spielen
	CASE 1
		GOSUB Anleitung
	CASE 2
		GOSUB Editor
	CASE 3
		' Ende
	CASE ELSE
		STOP  ' Sollte nicht vorkommen
	END SELECT
LOOP UNTIL mp1% = 3

SCREEN 0
WIDTH 80, 25
PRINT "Autorennen beendet."
FOR i% = -10 TO 10
	PRINT i%; FRE(i%)
NEXT i%
END

' +----------------+
' | Rennbahneditor |
' +----------------+
Editor:
CLS
	 
' Seitenmen ausgeben (verkleinerte Teile)
alt% = bahn%(0, 0)
FOR a% = 0 TO 29
	bahn%(0, 0) = a%
	ZeichneTeil 0, 0
	zx% = 1 + 21 * (a% MOD 3)
	zy% = 4 + 19 * (a% \ 3)
	FOR i% = 0 TO 13
		FOR j% = 0 TO 18
			PSET (zx% + j%, zy% + i%), POINT(68 + 5 * j% - j% \ 5, 5 * i%)
		NEXT j%
	NEXT i%
NEXT a%
bahn%(0, 0) = alt%

LOCATE 22, 1
COLOR 12
PRINT "X";
COLOR 15
PRINT "=Lsch.";
LOCATE 23, 1
COLOR 12
PRINT "M";
COLOR 15
PRINT "=Malm.";
LOCATE 24, 1
COLOR 12
PRINT "L";
COLOR 15
PRINT "=Laden";
LOCATE 25, 1
COLOR 12
PRINT "S";
COLOR 15
PRINT "=Speic.";

AktT% = 0  ' aktuelles Teil
cx% = 3
cy% = 2
malm% = 0
ZeichneBahneditorCursor AktT%, 14
ZeichneRennbahn

drinb2% = -1
WHILE drinb2%
	' Cursor darstellen
	LINE (64 + 96 * cx%, 70 * cy%)-STEP(95, 13), 15, BF
	LINE (64 + 96 * cx%, 56 + 70 * cy%)-STEP(95, 13), 15, BF
	LINE (64 + 96 * cx%, 14 + 70 * cy%)-STEP(18, 41), 15, BF
	LINE (141 + 96 * cx%, 14 + 70 * cy%)-STEP(18, 41), 15, BF
	DO
		t$ = INKEY$
	LOOP WHILE t$ = ""
	ZeichneTeil cx%, cy%
	SELECT CASE t$
	CASE CHR$(0) + "H"
	 IF malm% THEN
		 r% = 1
		 GOSUB Malmodus
		END IF
		cy% = (cy% + 4) MOD 5
	CASE CHR$(0) + "K"
	 IF malm% THEN
		 r% = 2
		 GOSUB Malmodus
		END IF
		cx% = (cx% + 5) MOD 6
	CASE CHR$(0) + "M"
		IF malm% THEN
			r% = 0
			GOSUB Malmodus
		END IF
		cx% = (cx% + 1) MOD 6
	CASE CHR$(0) + "P"
		IF malm% THEN
			r% = 3
			GOSUB Malmodus
		END IF
		cy% = (cy% + 1) MOD 5
	CASE " "
		COLOR 11
		LOCATE 19, 1
		PRINT "Teil";
		LOCATE 20, 1
		PRINT "whlen";
		alt% = AktT%
		drinb3% = -1
		WHILE drinb3%
			ZeichneBahneditorCursor AktT%, 15
			DO
				t$ = INKEY$
			LOOP WHILE t$ = ""
			ZeichneBahneditorCursor AktT%, 0
			SELECT CASE t$
			CASE CHR$(0) + "H"
				AktT% = (AktT% + 27) MOD 30
			CASE CHR$(0) + "K"
				AktT% = (AktT% + 29) MOD 30
			CASE CHR$(0) + "M"
				AktT% = (AktT% + 1) MOD 30
			CASE CHR$(0) + "P"
				AktT% = (AktT% + 3) MOD 30
			CASE CHR$(13), " "
				drinb3% = 0
			CASE CHR$(27)
				drinb3% = 0
				AktT% = alt%
			END SELECT
		WEND
		ZeichneBahneditorCursor AktT%, 14
		LOCATE 19, 1
		PRINT SPACE$(4);
		LOCATE 20, 1
		PRINT SPACE$(6);
	CASE CHR$(13)
		bahn%(cx%, cy%) = AktT%
		ZeichneTeil cx%, cy%
	CASE "X", "x"
		' Strecke lschen
		ZeichneRahmen 30, 12, 53, 14, 13
		LOCATE 13, 31
		COLOR 14
		PRINT "Sind Sie sicher? (J/N)"
		DO
			t$ = INKEY$
		LOOP UNTIL UCASE$(t$) = "J" OR UCASE$(t$) = "N" OR t$ = CHR$(27)
		IF UCASE$(t$) = "J" THEN
			InitialisiereRennbahn
			ZeichneRennbahn
		ELSE
			FOR i% = 1 TO 3
				ZeichneTeil i%, 2
			NEXT i%
		END IF
	CASE "m", "M"
		' Malmodus
		malm% = NOT malm%
		LOCATE 21, 1
		IF malm% THEN
			COLOR 14
			PRINT "Malm.";
			r1% = -1
		ELSE
			PRINT SPACE$(6);
		END IF
	CASE "l", "L"
		' Laden
		ZeichneRahmen 27, 12, 56, 14, 13
		LOCATE 13, 28
		COLOR 14
		PRINT "Laden von Strecke: ";
		EditiereZeile rennb$, e%
		IF e% = 0 THEN
			LadeRennbahn
			ZeichneRennbahn
		ELSE
			FOR i% = 1 TO 3
				ZeichneTeil i%, 2
			NEXT i%
		END IF
	CASE "s", "S"
		' Speichern: Zuerst Plausibilittsscheck ntig
		' (keine offenen Enden, nur 1 Start)
		tx% = -1
		ty% = -1
		s% = 0
		' Horizontale Enden
		FOR i% = 0 TO 4
			FOR j% = 0 TO 6
				IF bahn%(j%, i%) >= 10 AND bahn%(j%, i%) <= 13 THEN
					s% = s% + 1
					IF s% > 1 THEN
						tx% = j%
						ty% = i%
					END IF
				END IF
				IF (tbesch(bahn%(j% - 1, i%)).attr AND 37) = 0 XOR (tbesch(bahn%(j%, i%)).attr AND 25) = 0 THEN
					ty% = i%
					IF j% = 6 THEN
						tx% = 5
					ELSE
						tx% = j%
					END IF
				END IF
			NEXT j%
		NEXT i%
		FOR i% = 0 TO 5
			FOR j% = 0 TO 5
				IF (tbesch(bahn%(j%, i% - 1)).attr AND 50) = 0 XOR (tbesch(bahn%(j%, i%)).attr AND 14) = 0 THEN
					tx% = j%
					IF i% = 5 THEN
						ty% = 4
					ELSE
						ty% = i%
					END IF
				END IF
			NEXT j%
		NEXT i%
		IF s% = 1 AND tx% = -1 AND ty% = -1 THEN
			ZeichneRahmen 23, 12, 60, 14, 13
			LOCATE 13, 24
			COLOR 14
			PRINT "Speichern der Strecke als: ";
			EditiereZeile rennb$, e%
			IF e% = 0 THEN
				SpeichereRennbahn
			END IF
			FOR i% = 1 TO 4
				ZeichneTeil i%, 2
			NEXT i%
		ELSE
			IF tx% <> -1 AND ty% <> -1 THEN
				cx% = tx%
				cy% = ty%
			END IF
			ErzeugeBieps
		END IF
	CASE CHR$(27)
		drinb2% = 0
	CASE ELSE
		ErzeugeBieps
	END SELECT
WEND
RETURN

Malmodus:
IF r1% = -1 THEN
	r1% = (r% + 2) AND 3
END IF

IF tbesch(bahn%(cx%, cy%)).attr <> (tbesch(bahn%(cx%, cy%)).attr OR mmod%(r%, r1%)) THEN
	t% = -1
	FOR i% = 29 TO 0 STEP -1
		IF tbesch(i%).attr = (tbesch(bahn%(cx%, cy%)).attr OR mmod%(r%, r1%)) THEN
			t% = i%
		END IF
	NEXT i%
	IF t% <> -1 THEN
		bahn%(cx%, cy%) = t%
		ZeichneTeil cx%, cy%
	ELSE
		ErzeugeBieps
	END IF
END IF
r1% = r%
RETURN


' +-------+
' | Spiel |
' +-------+

' Start Spiel
Spielen:

CLS
PRINT "00:01:53"
PRINT "Noch"
PRINT "nicht"
PRINT "imple-"
PRINT "men-"
PRINT "tiert!"
ZeichneRennbahn
fl% = -1
' Nur Demo!
FOR i% = 0 TO 6
	sp(i%).r = i% AND 3
NEXT i%

PCOPY 0, 1
SCREEN , , 1

ts! = 0!
t0! = TIMER + 30!
FOR i% = 0 TO 15
	tRoh!(i%) = TIMER - t0!
	ts! = ts! + tRoh!(i%)
NEXT i%
t! = TIMER - t0!
p% = 0

t01! = TIMER: ii& = 0&
WHILE INKEY$ = ""
	tRohNeu! = TIMER - t0!
	t! = t! + (16! * tRohNeu! - ts!) / 136!
	ts! = ts! + tRohNeu! - tRoh!(p%)
	tRoh!(p%) = tRohNeu!
	p% = p% + 1 AND 15
	w0! = t! * Pi! / 3!
	IF NOT fl% THEN
		FOR i% = 6 TO 0 STEP -1
			PUT (sp(i%).l.xi, sp(i%).l.yi), clr%(0, i%), PSET
		NEXT i%
	END IF
	FOR i% = 0 TO 6
		w! = w0! / CSNG(i% + 1)
		vx! = COS(w!)
		vy! = SIN(w!)
		sp(i%).x = 3! + .3 * CSNG(i% + 1) * vx!
		sp(i%).y = 2.5 + .3 * CSNG(i% + 1) * vy!
		sp(i%).vx = -vy!
		sp(i%).vy = vx!
		ZeichneAuto sp(i%), i%
	NEXT i%
	IF fl% THEN
		FOR i% = 0 TO 6
			sp(i%).v = sp(i%).l
		NEXT i%
		fl% = 0
	END IF
	FOR i% = 0 TO 6
		IF sp(i%).l.xi < sp(i%).v.xi THEN
			xi% = sp(i%).l.xi
		ELSE
			xi% = sp(i%).v.xi
		END IF
		IF sp(i%).l.xa > sp(i%).v.xa THEN
			xa% = sp(i%).l.xa
		ELSE
			xa% = sp(i%).v.xa
		END IF
		IF sp(i%).l.yi < sp(i%).v.yi THEN
			yi% = sp(i%).l.yi
		ELSE
			yi% = sp(i%).v.yi
		END IF
		IF sp(i%).l.ya > sp(i%).v.ya THEN
			ya% = sp(i%).l.ya
		ELSE
			ya% = sp(i%).v.ya
		END IF
		' LINE (xi%, yi%)-(xa%, ya%), 4, B
		GET (xi%, yi%)-(xa%, ya%), trans%
		SCREEN , , 0
		PUT (xi%, yi%), trans%, PSET
		SCREEN , , 1, 0
	NEXT i%
	ii& = ii& + 1&
WEND
t02! = TIMER - t01!
SCREEN , , 0, 0

PRINT CSNG(ii&) / t02!
d$ = INPUT$(1)
RETURN

Anleitung:
Seite% = 1
DO
	COLOR 2, 0
	CLS
	PRINT "Autorennen - Seite"; Seite%; "von 3"
	COLOR 1
	PRINT STRING$(39, 205)
	COLOR 7
	SELECT CASE Seite%
	CASE 1
		COLOR 7
		PRINT
		PRINT "Noch nicht implementiert! :-("
	CASE 2
		PRINT "Noch nicht implementiert! :-("
	CASE 3
		COLOR 11
		PRINT "Noch nicht implementiert! :-("
	END SELECT
	LOCATE 24, 1
	COLOR 1
	PRINT STRING$(39, 205);
	LOCATE 25, 1
	COLOR 4: PRINT "Bild"; CHR$(24);
	COLOR 2: PRINT "/";
	COLOR 4: PRINT "Bild"; CHR$(25);
	COLOR 2: PRINT " Blttern ";
	COLOR 4: PRINT "Esc";
	COLOR 2: PRINT " Verlassen";
	DO
		t$ = INKEY$
	LOOP WHILE t$ = ""
	SELECT CASE t$
	CASE CHR$(0) + "H", CHR$(0) + "I"
		Seite% = (Seite% + 1) MOD 3 + 1
	CASE CHR$(0) + "P", CHR$(0) + "Q"
		Seite% = Seite% MOD 3 + 1
	CASE CHR$(0) + "G"
		Seite% = 1
	CASE CHR$(0) + "O"
		Seite% = 3
	END SELECT
LOOP UNTIL t$ = CHR$(27)
RETURN

FUNCTION BestimmeFarbe% (p!)
	IF p! > 35 THEN
		q! = 70! - p!
		streifen% = -2
	ELSE
		q! = p!
		streifen% = -3
	END IF
	SELECT CASE q!
	CASE IS < 8!
		BestimmeFarbe% = 2
	CASE IS < 10!
		BestimmeFarbe% = streifen% - 2
	CASE IS < 11!
		BestimmeFarbe% = 8
	CASE IS < 13!
		BestimmeFarbe% = 2
	CASE IS < 16!
		BestimmeFarbe% = streifen%
	CASE IS < 34!
		BestimmeFarbe% = 7
	CASE ELSE
		BestimmeFarbe% = -1
	END SELECT
END FUNCTION

FUNCTION BestimmeLinearFarbe% (u!, v!)
	z% = BestimmeFarbe(u!)
	IF z% < 0 THEN
		SELECT CASE z%
		CASE IS <= -4
			t! = v! / 7!
			IF ABS(t! - INT(t!) - .5) < 5! / 14! THEN
				BestimmeLinearFarbe% = 2
			ELSE
				BestimmeLinearFarbe% = 8
			END IF
		CASE IS <= -2
			t! = v! / 14!
			IF ABS(t! - INT(t!) - .5) < 3! / 14! THEN
				BestimmeLinearFarbe% = 15
			ELSE
				BestimmeLinearFarbe% = 4
			END IF
		CASE ELSE
			t! = v! / 14!
			IF ABS(t! - INT(t!) - .5) < 2! / 7! THEN
				BestimmeLinearFarbe% = 7
			ELSE
				BestimmeLinearFarbe% = 15
			END IF
		END SELECT
	ELSE
		BestimmeLinearFarbe% = z%
	END IF
END FUNCTION

FUNCTION Bruecke% (u!, v!, f1%, f2%)
	IF u! > 5! AND u! < 65! THEN
		IF v! > 5! AND v! < 65! THEN
			IF v! > 7! AND v! < 63! THEN
				IF f1% = 2 THEN
					Bruecke% = 7
				ELSE
					Bruecke% = f1%
				END IF
			ELSE
				Bruecke% = 6
			END IF
		ELSE
			Bruecke% = f2%
		END IF
	ELSE
		Bruecke% = f1%
	END IF
END FUNCTION

SUB EditiereZeile (e$, e%)
	' Ermglicht das Editieren eines Strings
 
	' Eingangsparameter:
	' e$       : String mit Vorgabeinhalt (die Lnge bestimmt zugleich die
	'            Lnge des Eingabefeldes
	' Ins%      : Flag fr Einfgemodus (-1 = Eingfgen ; 0 = berschreiben)
	'            (SHARED-Variable)
	
	' Ausgangsparameter:
	' e$       : String mit fertiger Eingabe
	' e%       : 0=mit <Return> abgeschlossen, 1=mit <Esc>
	
	y% = CSRLIN
	x% = POS(0)
	l% = LEN(e$)
	p% = LEN(RTRIM$(e$))
	Al$ = e$
	e% = -1
	DO
		LOCATE y%, x%
		FarbPrint 1, 15, e$
		IF p% = LEN(e$) THEN
			FarbPrint 15, 1, " "
		ELSE
			FarbPrint 15, 0, " "
			LOCATE , x% + p%, 1
			FarbPrint 15, 4 + 3 * Ins%, MID$(e$, p% + 1, 1)
		END IF
		DO
			t$ = INKEY$
		LOOP WHILE t$ = ""
		SELECT CASE t$
		CASE CHR$(0) + "K"
			IF p% THEN
				p% = p% - 1
			ELSE
				ErzeugeBieps
			END IF
		CASE CHR$(0) + "M"
			IF p% < l% - 1 THEN
				p% = p% + 1
			ELSE
				ErzeugeBieps
			END IF
		CASE " " TO "~", "" TO ""
			IF Ins% THEN
				e$ = LEFT$(e$, p%) + t$ + MID$(e$, p% + 1, l% - 1 - p%)
			ELSE
				MID$(e$, p% + 1, 1) = t$
			END IF
			IF p% < l% - 1 THEN
				p% = p% + 1
			ELSE
				ErzeugeBieps
			END IF
		CASE CHR$(8)
			p% = p% - 1
			IF p% = -1 THEN
				ErzeugeBieps
				p% = 0
			ELSE
				e$ = LEFT$(e$, p%) + MID$(e$, p% + 2, l% - 1 - p%) + " "
			END IF
		CASE CHR$(0) + "S"
			e$ = LEFT$(e$, p%) + MID$(e$, p% + 2, l% - 1 - p%) + " "
		CASE CHR$(0) + "O"
			p% = l%
			DO WHILE MID$(e$, p%, 1) = " "
				p% = p% - 1
			LOOP
			p% = p% + (p% = l%)
		CASE CHR$(0) + "G"
			p% = 0
		CASE CHR$(0) + "u"
			MID$(e$, p% + 1) = SPACE$(l% - p%)
		CASE CHR$(0) + "w"
			e$ = RIGHT$(e$, l% - p%) + SPACE$(p%)
			p% = 0
		CASE CHR$(0) + "R"
			Ins% = NOT Ins%
			LOCATE , , , 6 + 4 * Ins%, 7
		CASE CHR$(0) + "s"
			IF p% THEN
				DO
					p% = p% - 1
				LOOP UNTIL MID$(" " + e$, p% + 1, 1) = " " AND MID$(e$, p% + 1, 1) <> " " OR p% = 0
			ELSE
				ErzeugeBieps
			END IF
		CASE CHR$(0) + "t"
			IF p% = l% - 1 THEN
				ErzeugeBieps
			ELSE
				DO
					p% = p% + 1
				LOOP UNTIL MID$(e$, p%, 1) = " " AND MID$(e$, p% + 1, 1) <> " " OR p% = l% - 1
			END IF
		CASE CHR$(0) + "="
			e$ = Al$
			p% = 0
		CASE CHR$(0) + "<"
			b% = 0
			e$ = SPACE$(l%)
			p% = 0
		CASE CHR$(9)
			b% = 0
			IF p% = l% - 1 THEN
				ErzeugeBieps
			ELSE
				p% = 8 * (p% \ 8) + 8
				IF p% >= l% THEN
					p% = l% - 1
				END IF
			END IF
		CASE CHR$(0) + CHR$(15)
			IF p% THEN
				p% = 8 * ((p% - 1) \ 8)
			ELSE
				ErzeugeBieps
			END IF
		CASE CHR$(13)
			e% = 0
		CASE CHR$(27)
			e% = 1
			e$ = Al$
		CASE ELSE
			ErzeugeBieps
		END SELECT
	LOOP WHILE e% = -1
	LOCATE y%, x%
	COLOR 6
	PRINT e$; " ";
END SUB

SUB ErzeugeBieps
	SOUND 880! * 2! ^ (2! / 3!), 1!
END SUB

SUB FarbPrint (fg%, hg%, t$)
	DIM h%(28 * LEN(t$) + 1)
	IF t$ <> "" THEN
		x% = 8 * (POS(0) - 1)
		y% = 14 * (CSRLIN - 1)
		COLOR fg% XOR hg%
		PRINT t$;
		GET (x%, y%)-STEP(8 * LEN(t$) - 1, 13), h%
		LINE (x%, y%)-STEP(8 * LEN(t$) - 1, 13), hg%, BF
		PUT (x%, y%), h%, XOR
	END IF
	ERASE h%
END SUB

' String mit fhrenden Nullen bilden
FUNCTION FuehrNull$ (w%, a%)
	h$ = MID$(STR$(w%), 2)
	FuehrNull$ = STRING$(a% - LEN(h$), "0") + h$
END FUNCTION

SUB GibErklaerungAus (t$)
	COLOR 14
	LOCATE 24, 10
	PRINT LSetF$(t$, 62);
END SUB

SUB GibSpielerDetailsAus (s%, m%)
	LOCATE 16 + s%, 10
	IF m% = 1 THEN
		FarbPrint 1, 7, sp(s%).na
	ELSE
		FarbPrint 6, 0, sp(s%).na
	END IF
	COLOR 7
	PRINT "";
	SELECT CASE m%
	CASE -2
		h% = 15
		h2% = 8
	CASE 2
		h% = 7
		h2% = 0
	CASE ELSE
		h% = 0
		h2% = 0
	END SELECT
	SELECT CASE sp(s%).typ
	CASE 0 TO 6
		FarbPrint 10 - h2%, h%, LSetF$("Tastatur" + STR$(sp(s%).typ + 1), 12)
	CASE 7 TO 8
		FarbPrint 14 - h2%, h%, LSetF$("Joystick" + STR$(sp(s%).typ - 6), 12)
	CASE IS >= 9
		FarbPrint 11 - h2%, h%, LSetF$("Computer" + STR$(sp(s%).typ - 8), 12)
	END SELECT
	COLOR 7
	PRINT "";
	SELECT CASE m%
	CASE 3
		h% = 8
	CASE -3
		h% = 4
	CASE ELSE
		h% = 7
	END SELECT
	FarbPrint 0, h%, SPACE$(7)
	py% = 211 + 14 * s%
	PUT (290, py%), AndM%, AND
	h% = sp(s%).f
	FOR i% = 0 TO 2
		IF h% AND 1 THEN
			PUT (290, py%), aut%(0, i%), OR
		END IF
		h% = h% \ 2
	NEXT i%
	COLOR 7
	PRINT "";
	SELECT CASE sp(s%).typ
	CASE 0 TO 6
		FOR i% = 0 TO 3
			COLOR 7
			PRINT " "; MID$("LRGB", i% + 1, 1); ":";
			SELECT CASE m%
			CASE i% + 4
				h% = 7
			CASE -i% - 4
				h% = 15
			CASE ELSE
				h% = 0
			END SELECT
			h2% = tasten%(4 * sp(s%).typ + i%)
			IF h2% AND 256 THEN
				FarbPrint 1, h%, "@"
			ELSE
				FarbPrint 1, h%, " "
			END IF
			SELECT CASE h2% AND 255
			CASE 7
				FarbPrint 14, h%, CHR$(14)
			CASE 9 TO 13
				FarbPrint 14, h%, MID$("TRHC>", (h2% AND 255) - 8, 1)
			CASE 28 TO 31
				FarbPrint 14, h%, CHR$(28 + (h2% + 2 AND 3))
			CASE ELSE
				FarbPrint 6, h%, CHR$(h2% AND 255)
			END SELECT
		NEXT i%
	CASE 7 TO 8
		IF m% >= 4 THEN
			h% = 7
		ELSEIF m% <= -4 THEN
			h% = 15
		ELSE
			h% = 0
		END IF
		FarbPrint 8, h%, " Kalibrieren        "
	CASE IS >= 9
		IF m% >= 4 THEN
			h% = 7
		ELSEIF m% <= -4 THEN
			h% = 15
		ELSE
			h% = 0
		END IF
		FarbPrint 8, h%, " Nicht implementiert"
	END SELECT
END SUB

SUB InitialisiereRennbahn
	' Rennbahn initialisieren: Alles lschen
	FOR i% = -1 TO 5
		FOR j% = -1 TO 6
			bahn%(j%, i%) = 0
		NEXT j%
	NEXT i%
END SUB

SUB LadeRennbahn
	OPEN RTRIM$(rennb$) + ".tck" FOR INPUT AS 1
	CLOSE 1
	OPEN RTRIM$(rennb$) + ".tck" FOR BINARY AS 1
	k$ = INPUT$(8, 1)
	IF k$ <> "RennBahn" THEN
		' Nicht Rennbahndatei
		STOP
	END IF
	FOR y% = 0 TO 4
		FOR x% = 0 TO 5
			bahn%(x%, y%) = ASC(INPUT$(1, 1))
		NEXT x%
	NEXT y%
	CLOSE 1
END SUB

FUNCTION LSetF$ (t$, l%)
	IF LEN(t$) > l% THEN
		LSetF$ = LEFT$(t$, l%)
	ELSE
		LSetF$ = t$ + SPACE$(l% - LEN(t$))
	END IF
END FUNCTION

FUNCTION Polarwinkel! (dx!, dy!)
	IF dx! = 0! THEN
		IF dy! < 0! THEN
			Polarwinkel! = Pi! / 2!
		ELSE
			Polarwinkel! = -Pi! / 2!
		END IF
	ELSEIF dx! > 0! THEN
		Polarwinkel! = -ATN(dy! / dx!)
	ELSE
		Polarwinkel! = Pi! - ATN(dy! / dx!)
	END IF
END FUNCTION

FUNCTION Rennauto% (u!, v!)
	IF ABS(v!) < 6! THEN
		SELECT CASE u!
		CASE IS <= -14
			Rennauto% = 7
		CASE IS <= -6
			IF u! < -11.8 THEN
				' Heck
				Rennauto% = 1
			ELSEIF ABS(v!) < 3.4 THEN
				Rennauto% = 9
			ELSEIF u! > -11 THEN
				' Pneu
				Rennauto% = 0
			ELSE
				Rennauto% = 7
			END IF
		CASE IS <= 14
			IF u! > -5! AND u! < 3 AND ABS(v!) < 2! THEN
				' Fhrerkabine
				IF SQR((u! + 2!) ^ 2! + v! * v!) < 1.2 THEN
					' Fhrer
					Rennauto% = 14
				ELSE
					Rennauto% = 0
				END IF
			ELSEIF ABS(v!) < 4.8 AND ABS(v!) < 6.5 - u! OR ABS(v!) < (24! - u!) * .07 THEN
				' Chassisprofil
				Rennauto% = 9
			ELSEIF u! > 12! AND ABS(v!) < 4.8 THEN
				' Stossstange
				IF ABS(v!) < 3.8 THEN
					Rennauto% = 1
				ELSE
					Rennauto% = 9
				END IF
			ELSEIF u! > 6! AND u! < 11! AND ABS(v!) > 3! AND ABS(v!) < 5.6 THEN
				' Pneu
				Rennauto% = 0
			ELSEIF u! < 9! AND ABS(v!) < 1.25 * (u! - 5.5) THEN
				' Lenkachsen
				Rennauto% = 8
			ELSE
				Rennauto% = 7
			END IF
		CASE ELSE
			Rennauto% = 7
		END SELECT
	ELSE
		Rennauto% = 7
	END IF
END FUNCTION

SUB SpeichereRennbahn
	OPEN RTRIM$(rennb$) + ".tck" FOR OUTPUT AS 1
	PRINT #1, "RennBahn";
	FOR y% = 0 TO 4
		FOR x% = 0 TO 5
			PRINT #1, CHR$(bahn%(x%, y%));
		NEXT x%
	NEXT y%
	CLOSE 1
END SUB

FUNCTION Start% (u!, v!, f%)
	h! = ABS(ABS(v! - 35!) - 10.5)
	IF u! > 27! THEN
		IF h! < 1.5 THEN
			' Pfeilende
			Start% = 15
		ELSE
			Start% = f%
		END IF
	ELSEIF u! - 2! * h! > 20! THEN
		' Pfeilspitze
		Start% = 15
	ELSE
		hu! = ABS(u! - 10!)
		hv! = ABS(ABS(ABS(v! - 35!) - 4.5) - 4.5)
		r! = SQR(hu! * hu! + hv! * hv!)
		SELECT CASE r!
		CASE IS < 2.8
			Start% = 8
		CASE IS < 3.9
			Start% = 7
		CASE IS < 6.8
			Start% = 0
		CASE ELSE
			IF hu! < 7! AND hv! < 23! THEN
				IF hv! > 21! THEN
					Start% = 0
				ELSEIF hu! > 6! OR hu! < 4! THEN
					Start% = f%
				ELSEIF hv! > 20! OR r! < 8.2 THEN
					Start% = 8
				ELSE
					Start% = 0
				END IF
			ELSE
				Start% = f%
			END IF
		END SELECT
	END IF
END FUNCTION

SUB ZeichneAuto (a AS Spieler, n%)
	DIM m1%(13), m2%(13)
	a.v = a.l
	' Wagenstellung
	w% = CINT(Polarwinkel(a.vx, a.vy) * 24! / Pi!)
	IF w% < 0 THEN
		w% = w% + 48
	END IF
	fl% = w% > 24
	IF fl% THEN
		w% = 48 - w%
		a.l.yi = CINT(a.y * 70!) - aDet(w%).yGr - 1 + aDet(w%).yOffs
	ELSE
		a.l.yi = CINT(a.y * 70!) - aDet(w%).yOffs
	END IF
	a.l.xi = CINT(a.x * 96!) - aDet(w%).xOffs
	a.l.xa = a.l.xi + aDet(w%).xGr
	a.l.ya = a.l.yi + aDet(w%).yGr
	' Alter Ausschnitt sichern
	GET (a.l.xi, a.l.yi)-(a.l.xa, a.l.ya), clr%(0, n%)
	IF fl% THEN
		FOR i% = 0 TO (aDet(w%).yGr - 1) \ 2
			GET (a.l.xi, a.l.yi + i%)-STEP(aDet(w%).xGr, 0), m1%
			GET (a.l.xi, a.l.ya - i%)-STEP(aDet(w%).xGr, 0), m2%
			PUT (a.l.xi, a.l.ya - i%), m1%, PSET
			PUT (a.l.xi, a.l.yi + i%), m2%, PSET
		NEXT i%
	END IF
	PUT (a.l.xi, a.l.yi), AndM%(aDet(w%).ptr), AND
	h% = 1
	FOR i% = 0 TO 2
		IF a.f AND h% THEN
			PUT (a.l.xi, a.l.yi), aut%(aDet(w%).ptr, i%), OR
		END IF
		h% = 2 * h%
	NEXT i%
	IF fl% THEN
		FOR i% = 0 TO (aDet(w%).yGr - 1) \ 2
			GET (a.l.xi, a.l.yi + i%)-STEP(aDet(w%).xGr, 0), m1%
			GET (a.l.xi, a.l.ya - i%)-STEP(aDet(w%).xGr, 0), m2%
			PUT (a.l.xi, a.l.ya - i%), m1%, PSET
			PUT (a.l.xi, a.l.yi + i%), m2%, PSET
		NEXT i%
	END IF
END SUB

SUB ZeichneBahneditorCursor (t%, f%)
	px% = 9 + 21 * (t% MOD 3)
	py% = 3 + 19 * (t% \ 3)
	FOR i% = 0 TO 3
		LINE (px% - 2 * i%, py% - i%)-STEP(2 + 4 * i%, 0), f%
		LINE (px% - 2 * i%, py% + 15 + i%)-STEP(2 + 4 * i%, 0), f%
	NEXT i%
END SUB

SUB ZeichneRahmen (x1%, y1%, x2%, y2%, f%)
	LOCATE y1%, x1%
	COLOR f%
	PRINT ""; STRING$(x2% - x1% - 1, 205); "";
	FOR y% = y1% + 1 TO y2% - 1
		LOCATE y%, x1%
		PRINT ""; SPACE$(x2% - x1% - 1); "";
	NEXT y%
	LOCATE y2%, x1%
	PRINT ""; STRING$(x2% - x1% - 1, 205); "";
END SUB

SUB ZeichneRennbahn
	FOR y% = 0 TO 4
		FOR x% = 0 TO 5
			ZeichneTeil x%, y%
		NEXT x%
	NEXT y%
END SUB

SUB ZeichneTeil (x%, y%)
	DIM m%(25)
	xp% = 64 + 96 * x%
	yp% = 35 + 70 * y%
	PUT (xp%, yp% - 34), teil%(0, tbesch(bahn%(x%, y%)).slu), PSET
	PUT (xp% + 48, yp% - 34), teil%(0, tbesch(bahn%(x%, y%)).sru), PSET
	' Spiegeln
	FOR i% = 1 TO 34
		GET (xp%, yp% - i%)-STEP(95, 0), m%
		PUT (xp%, yp% + i%), m%, PSET
	NEXT i%
	PUT (xp%, yp% - 35), teil%(0, tbesch(bahn%(x%, y%)).slo), PSET
	PUT (xp% + 48, yp% - 35), teil%(0, tbesch(bahn%(x%, y%)).sro), PSET
END SUB

SUB ZeigeCursor (x%, y%, el%, t$)
	' PUT (x%, y%), csr%, OR
	csEin% = -1
	nB! = TIMER + .5
	DO
		t$ = INKEY$
		IF TIMER > nB! THEN
			IF csEin% THEN
				' PUT (x%, y%), sh%(122 * el%), PSET
			ELSE
				' PUT (x%, y%), csr%, OR
			END IF
			csEin% = NOT csEin%
			nB! = nB! + .5
		END IF
	LOOP WHILE t$ = ""
	IF csEin% THEN
		' PUT (x%, y%), sh%(122 * el%), PSET
	END IF
END SUB

